import sys, os, time

from preferences import preferences

class Log:
	errors = []
	
	def __init__( self, logpath ):
		if not os.path.exists( logpath ):
			self.file = open( logpath, "w" )
		else: self.file = open( logpath, "a" )

	def __Format( self, message, type="" ):
		t = time.strftime( "%F %T" )
		return "%s %s: %s\n" % ( t, type, message )
	
	def Debug( self, message ):
		self.file.write( self.__Format( message, "Debug" ) )
		if preferences["debug"]:
			sys.stdout.write( "D %s\n" % message )
	
	def Log( self, message, flush = True ):
		self.file.write( self.__Format( message ) )
		if preferences["debug"]:
			sys.stdout.write( "L %s\n" % message )
		if flush: self.file.flush()
	
	def Warn( self, message ):
		self.file.write( self.__Format( message, "Warning" ) );
		self.file.flush()
		sys.stderr.write( "*W* %s\n" % message )
	
	def Error( self, message ):
		self.file.write( self.__Format( message, "Error" ) );
		self.file.flush()
		sys.stderr.write( "*E* %s\n" % message )
		if len( self.errors ) > 0 and self.errors[-1][0] == message:
			self.errors[-1][1] += 1
		else: self.errors += [[message, 1]]
	
	def __times( self, number ):
		return number == 1 and "1 time" or ( "%d times" % number )
	
	def GetErrors ( self ):
		return "\n".join( ["Reported %s: <i>%s</i>" % ( self.__times( count ), message ) for message, count in self.errors] )
	
	def ClearErrors ( self ):
		del self.errors[:]

# wineroot doesn't necessarily exist just yet so we can't put the log there
log = Log( os.path.expanduser( "~/.wine-doors.log" ) )

if __name__ == "__main__":
	log.Debug( "unittest" )
	log.Log( "unittest" )
	log.Warn( "unittest" )
	log.Error( "unittesting" )
	log.Error( "unittesting_twice" )
	log.Error( "unittesting_twice" )
	print log.getErrors()
	if log.getErrors() == "Reported 1 time <i>unittesting</i>\nReported 2 times <i>unittesting_twice</i>":
		print "OK"
	log.clearErrors()
	print log.getErrors()
	if log.getErrors() == "":
		print "OK"