import gtk, gobject
import sys, os, urllib
import re

from const import *
from ctile import Tile
from preferences import preferences
from packlist import packlist
from queue import queue
from wine import wine
from log import log

def ReposFromModel(model, path, iter ):
    name = model.get_value( iter, REPO_NAME )
    uri = model.get_value( iter, REPO_URI )
    packlist.AddRepo( name, uri )

def SetProgress( percentage, type=POPUP, text=None, widget=None ):
    pass

# Todo: remove deprecated code, there is a lot of it now, mostly moved to GH_main
class GladeHandlers:
    #-------------------------------#
    #          Main window          #
    #-------------------------------#
    def on_tbn_update_clicked ( widget, data=None ):
        packlist.UpdateAll()
        #
    
    # Deprecate
    def on_tbn_list_browser_clicked( widget, data=None ):
        global packlist
        global in_queue
        global window
        in_queue = False
        window['tv_packlist'].set_model( packlist.CreateTreeModel() )
        window['nb_infopane'].set_current_page( 0 )
    # Deprecate    
    def on_tbn_queue_clicked( widget, data=None ):
        global queue
        global in_queue
        global window
        in_queue = True
        window['tv_packlist'].set_model( queue.CreateTreeModel() )
        window['nb_infopane'].set_current_page( 2 )
    # Deprecate
    def on_tbn_cedega_purchase_clicked( widget, data=None ):
        pass
    # Deprecate
    def on_tbn_crossover_purchase_clicked( widget, data=None ):
        pass
    
    #------------------------------------#
    #          Application info          #
    #------------------------------------#
    def on_cbb_version_changed( widget, data=None ):
        return
        
    def on_bt_add_to_queue_clicked( widget, data=None ):
        global queue
        global pack
        queue.Add( "install", pack )
        return
        
    def on_bt_process_queue_clicked( widget, data=None ):
        return
    
    #-------------------------------#
    #          Main window          #
    #-------------------------------#
    
    # THIS IS ALL DUPLICATED FOR NOW, DEPRECATE THIS COPY!!
    def on_update_package_list_activate ( widget, data=None ):
        return
        
    def on_cache_files_activate ( widget, data=None ):
        return
        
    def on_view_wine_processes_activate ( widget, data=None ):
        global wineproc
        try:
            wineproc['wn_wineproc'].show()
        except:
            wineproc = Window( "wn_wineproc" )
            
    def on_kill_all_wine_processes_activate ( widget, data=None ):
        wine.Kill()
        
    def on_reboot_wine_activate ( widget, data=None ):
        wine.Reboot()
        
    def on_quit_activate( widget, data=None ):
        gtk.main_quit()
        
    def on_preferences_activate( widget, data=None ):
        global wn_prefs
        try:
            wn_prefs['wn_prefs'].show()
        except:
            wn_prefs = Window( "wn_prefs" )
            column = gtk.TreeViewColumn( 'Repository Name', gtk.CellRendererText(), text=REPO_NAME )
            column.set_sort_column_id( REPO_NAME )
            wn_prefs['tv_repos'].append_column( column )
            
            column = gtk.TreeViewColumn( 'Repository URI', gtk.CellRendererText(), text=REPO_URI )
            column.set_sort_column_id( REPO_URI )
            wn_prefs['tv_repos'].append_column( column )
            
        wn_prefs['file_wineroot'].set_current_folder( preferences['wineroot'] )
        wn_prefs['ck_updateonstart'].set_active( eval( preferences['updateonstart'] ) )
        wn_prefs['ck_cvscedega'].set_active( eval( preferences['cvscedega'] ) )
        wn_prefs['ck_cedega'].set_active( eval( preferences['cedega'] ) )
        wn_prefs['ck_crossover'].set_active( eval( preferences['crossover'] ) )
        wn_prefs['ck_licensed'].set_active( eval( preferences['licensed'] ) )
        wn_prefs['en_name'].set_text( preferences['name' ] )
        wn_prefs['en_company'].set_text( preferences['company'] )       
        
        # Repo list store
        model = gtk.ListStore( gobject.TYPE_STRING, 
                               gobject.TYPE_STRING )
        for item in preferences.repositories:
            iter = model.append()
            model.set( iter, 
                      REPO_NAME, item[REPO_NAME], 
                      REPO_URI, item[REPO_URI] )
            
        wn_prefs['tv_repos'].set_model( model )
        wn_prefs['tv_repos'].set_search_column( REPO_NAME )
    
    
    # Move this to GH_Main
    # Deprecated!
    def on_tv_packlist_cursor_changed( widget, data=None ):
        global pack
        global window
        iter = window['tv_packlist'].get_selection().get_selected()[1]
        model = window['tv_packlist'].get_model()
        shortname = model.get_value( iter, PACK_SHORTNAME )
        for item in packlist.available:
            if item["shortname"] == shortname:
                pack = item
                break
        # Start setting the UI variables
        window['lb_app_name1'].set_markup( "<b><big>" + pack["name"] + "</big></b>" )
        window['lb_app_name2'].set_markup( "<b><big>" + pack["name"] + "</big></b>" )
        window['lb_vendor'].set_text( pack["vendor"] )
        window['lb_homepage'].set_text( pack['homepage'] )
        window['lb_category'].set_text( pack['category'] )
        text_buffer = window['tx_description'].get_buffer()
        text_buffer.set_text( pack['description'] )
        window['tx_description'].set_buffer( text_buffer )
        versions = pack['versions']
        window['cbb_version'].set_model( gtk.ListStore( gobject.TYPE_STRING ) )
        index = 0
        for item in versions:
            window['cbb_version'].append_text( item )
            try:
                if item == pack["default_version"]:
                    window['cbb_version'].set_active( index )
            except:
                window['cbb_version'].set_active( 0 )
            index = index+1
        
        if "icon" in pack:
            icon_url = pack['icon'].split( "/" )
        
        icon_file = icon_url[len( icon_url )-1]
        icon_file = preferences['wineroot'] + "/wine-doors/icons/" + icon_file
        
        if not os.path.isfile( icon_file ):
            urllib.urlretrieve( pack['icon'], icon_file )
        
        window['im_icon1'].set_from_file( icon_file )
        window['im_icon2'].set_from_file( icon_file )
        window['nb_infopane'].set_current_page( 1 )
        
    def on_wine_version_activate( widget, data=None ):
        pass
    def on_contents_activate( widget, data=None ):
        pass
    def on_about_activate( widget, data=None ):
        global about
        try: about['wn_about'].show()
        except: about = Window( "wn_about" )
        
    #-------------------------#
    #          About          #
    #-------------------------#
    def on_bt_close_about_clicked( widget, data=None ):
        global about
        about['wn_about'].hide()
    def on_bt_about_credits_clicked( widget, data=None ):
        global credits
        try: credits['wn_credits'].show()
        except: credits = Window( "wn_credits" )
    def on_bt_credits_close_clicked( widget, data=None ):
        credits['wn_credits'].hide()
    
    #-----------------------------#
    #          Wine Proc          #
    #-----------------------------#
    def on_bt_kill_proc_clicked ( widget, data=None ):
        return
    def on_bt_close_wineproc_clicked ( widget, data=None ):
        global wineproc
        wineproc['wn_wineproc'].hide() 
    
    #-------------------------------#
    #          Preferences          #
    #-------------------------------#
    def on_bt_delete_repo_clicked( widget, data=None ):
        global wn_prefs
        selection = wn_prefs['tv_repos'].get_selection()
        item = selection.get_selected()
        if item:
            item[0].remove( item[1] )

    def on_bt_add_repo_clicked( widget, data=None ):
        global wn_prefs
        repo_name = wn_prefs['en_repo_name'].get_text()
        wn_prefs['en_repo_name'].set_text( "" )
        repo_uri = wn_prefs['en_repo_uri'].get_text()
        wn_prefs['en_repo_uri'].set_text( "" )
        model = wn_prefs['tv_repos'].get_model()
        #FIXME: model may be None
        if repo_name == "" or repo_uri == "":
            return
        iter = model.append()
        model.set( iter, 
                  REPO_NAME, repo_name, 
                  REPO_URI, repo_uri )
    def on_bt_prefs_cancel_clicked( widget, data=None ):
        global wn_prefs
        wn_prefs['wn_prefs'].hide()
    def on_bt_prefs_ok_clicked( widget, data=None ):
        global wn_prefs
        preferences['wineroot']      = wn_prefs['file_wineroot'].get_current_folder()
        preferences['updateonstart'] = wn_prefs['ck_updateonstart'].get_active()
        preferences['cvscedega']     = wn_prefs['ck_cvscedega'].get_active()
        preferences['cedega']        = wn_prefs['ck_cedega'].get_active()
        preferences['crossover']     = wn_prefs['ck_crossover'].get_active() 
        preferences['licensed']      = wn_prefs['ck_licensed'].get_active()
        preferences['name']          = wn_prefs['en_name'].get_text()
        preferences['company']       = wn_prefs['en_company'].get_text()
        model = wn_prefs['tv_repos'].get_model()
        model.foreach( preferences.ReposFromModel )
        preferences.Save()
        wn_prefs['wn_prefs'].hide()
        	
    #-----------------------------#
    #          First run          #
    #-----------------------------#
    def on_bt_proceed_clicked( widget, data=None ):
        preferences["name"]     = window['en_name'].get_text()
        preferences["company"]  = window['en_company'].get_text()
        preferences['licensed'] = window['ck_licensed'].get_active()
        preferences.Save()
        queue.SetProgress()
        gobject.idle_add( queue.Execute( True ).next )
        
    def on_firstrun_cancel_clicked( widget, data=None ):
        gtk.main_quit()
        sys.exit( 0 )
    def quit( widget, data=None ):
        log.Debug( "Quit called" )
        gtk.main_quit()
    #-----------------------------#
    #    Error handling dialogs   #
    #-----------------------------#
    def CantLocateCD( widget, data=None ):
        pass
    def Messages ( widget, data=None ):
        global wn_errors
        if log.errors:
            try:
                wn_errors['wn_errors'].show()
            except:
                wn_errors = Window( "wn_errors" )
        else:
            return
        if log.errors:
            error_text = "<b>The following errors have been reported</b>\n"
            error_text += log.GetErrors()
        wn_errors['errors'].set_text( error_text )
    #-----------------------------#
    #    Generic Installer        #
    #-----------------------------#
    def GenericInstall ( widget, data=None ):
        global wn_generic_installmodel
        try:
            wn_generic_install['wn_generic_instrall'].show()
        except:
            wn_generic_install = Window( "wn_generic_install" )



class GH_Main: # These will probably be merged into the WineDoorsGUI class
    def quit( widget, data=None ):
        log.Debug( "Quit called" )
        gtk.main_quit()

    # Buttons
    def on_bn_update_clicked ( widget, data=None ):
        packlist.UpdateAll()
    
    # Menu
    def on_update_package_list_activate ( widget, data=None ):
        return
        
    def on_cache_files_activate ( widget, data=None ):
        return
        
    def on_view_wine_processes_activate ( widget, data=None ):
        global wineproc
        try:
            wineproc['wn_wineproc'].show()
        except:
            wineproc = Window( "wn_wineproc" )
            
    def on_kill_all_wine_processes_activate ( widget, data=None ):
        wine.Kill()
        
    def on_reboot_wine_activate ( widget, data=None ):
        wine.Reboot()
        
    def on_quit_activate( widget, data=None ):
        gtk.main_quit()
        
    def on_preferences_activate( widget, data=None ):
        global wn_prefs
        try:
            wn_prefs['wn_prefs'].show()
        except:
            wn_prefs = Window( "wn_prefs" )
            column = gtk.TreeViewColumn( 'Repository Name', gtk.CellRendererText(), text=REPO_NAME )
            column.set_sort_column_id( REPO_NAME )
            wn_prefs['tv_repos'].append_column( column )
            
            column = gtk.TreeViewColumn( 'Repository URI', gtk.CellRendererText(), text=REPO_URI )
            column.set_sort_column_id( REPO_URI )
            wn_prefs['tv_repos'].append_column( column )
            
        wn_prefs['file_wineroot'].set_current_folder( preferences['wineroot'] )
        wn_prefs['ck_updateonstart'].set_active( eval( preferences['updateonstart'] ) )
        wn_prefs['ck_cvscedega'].set_active( eval( preferences['cvscedega'] ) )
        wn_prefs['ck_cedega'].set_active( eval( preferences['cedega'] ) )
        wn_prefs['ck_crossover'].set_active( eval( preferences['crossover'] ) )
        wn_prefs['ck_licensed'].set_active( eval( preferences['licensed'] ) )
        wn_prefs['en_name'].set_text( preferences['name' ] )
        wn_prefs['en_company'].set_text( preferences['company'] )       
        
        # Repo list store
        model = gtk.ListStore( gobject.TYPE_STRING, 
                               gobject.TYPE_STRING )
        for item in preferences.repositories:
            iter = model.append()
            model.set( iter, 
                      REPO_NAME, item[REPO_NAME], 
                      REPO_URI, item[REPO_URI] )
            
        wn_prefs['tv_repos'].set_model( model )
        wn_prefs['tv_repos'].set_search_column( REPO_NAME )

    def on_wine_version_activate( widget, data=None ):
        pass
    def on_contents_activate( widget, data=None ):
        pass
    def on_about_activate( widget, data=None ):
        global about
        try: about['wn_about'].show()
        except: about = Window( "wn_about" )

    def on_tv_packlist_cursor_changed( widget, data=None ):
        # This should probably be some kind of html renderer, allowing some basic online browsing.
        # initial UI should be generated locally, online links should be made inactive when the user
        # is not connected to the internet. The best bet for this is more than likely gtkmozembed.
        
        global pack
        global window
        iter = window['tv_packlist'].get_selection().get_selected()[1]
        model = window['tv_packlist'].get_model()
        shortname = model.get_value( iter, PACK_SHORTNAME )
        for item in packlist.available:
            if item["shortname"] == shortname:
                pack = item
                break
        window['lb_vendor'].set_text( pack["vendor"] )
        window['lb_homepage'].set_text( pack['homepage'] )
        window['lb_category'].set_text( pack['category'] )
    
    def on_cb_filter_changed( widget, data=None ):
        # Check how it has changed and re-run filter model
        filter_text = window['cbe_filter'].child.get_text()
        filter_field = window['cb_filter'].get_active()
        
        if filter_field == 0:
            filter_field = ANY
        elif filter_field == 1:
            filter_field = NAME
        elif filter_field == 2:
            filter_field = DESCRIPTION
        elif filter_field == 3:
            filter_field = CATEGORY
        elif filter_field == 4:
            filter_field = REPOSITORY
        elif filter_field == 5:
            filter_field = VENDOR
        
        winedoors.tree.FilterModel(packlist.packs, filter_text, filter_field)
        
    def on_cbe_filter_changed( widget, data=None ):
        filter_text = window['cbe_filter'].child.get_text()
        filter_field = window['cb_filter'].get_active()
        
        if filter_field == 0:
            filter_field = ANY
        elif filter_field == 1:
            filter_field = NAME
        elif filter_field == 2:
            filter_field = DESCRIPTION
        elif filter_field == 3:
            filter_field = CATEGORY
        elif filter_field == 4:
            filter_field = REPOSITORY
        elif filter_field == 5:
            filter_field = VENDOR
        
        winedoors.tree.FilterModel(packlist.packs, filter_text, filter_field)
    
class WDTileCellRenderer ( gtk.GenericCellRenderer ):
    __gproperties__ = {
        "data": ( gobject.TYPE_PYOBJECT, "Data", "Data", gobject.PARAM_READWRITE ), 
    }
   
    def __init__( self ):
        self.__gobject_init__()
        self.data = None
        
    def do_set_property( self, pspec, value ):
        setattr( self, pspec.name, value )
        
    def do_get_property( self, pspec ):
        return getattr( self, pspec.name )
		
    def on_render( self, window, widget, background_area, cell_area, expose_area, flags ):
        if not self.data: return
        cairo = window.cairo_create()
        title, icon, short_description, rating, buttons = self.data
        
        Tile(cairo, True,
             title, 
             icon,
             short_description,
             rating, buttons, 
             cell_area )
       
    def on_get_size( self, widget, cell_area=None ):
        return ( 0, 0, 400, 60 )
            
gobject.type_register( WDTileCellRenderer )

from math import ceil
class PackTree:
    def __init__( self, widget ):
    	self.widget = widget
    	log.Debug("Creating a packtree")
        # This is just for testing
        packlist.Update( "System Global" )
        #if preferences['updateonstart']:
        #    packlist.UpdateAll()

        self.model = gtk.ListStore( gobject.TYPE_PYOBJECT, 
                                    gobject.TYPE_STRING,
                                    gobject.TYPE_STRING )
        
        column = gtk.TreeViewColumn( 'Application', WDTileCellRenderer(), data=PACK_TILE )
        column.set_sort_column_id( PACK_TILE )
        self.widget.append_column( column )
        
        column = gtk.TreeViewColumn( 'shortname', gtk.CellRendererText(), text=PACK_SHORTNAME )
        column.set_sort_column_id( PACK_SHORTNAME )
        column.set_visible( False )
        self.widget.append_column( column )
        
        column = gtk.TreeViewColumn( 'version', gtk.CellRendererText(), text=PACK_VERSION )
        column.set_sort_column_id( PACK_VERSION )
        column.set_visible( False )
        self.widget.append_column( column )
        
        self.widget.set_model( self.CreateModel( packlist.packs ) )
        self.widget.set_search_column( PACK_SHORTNAME )
        
        self.button_press = False
        # click and motion notify
        # motion notify should drop unless the mouse button is pressed
        self.widget.connect("motion-notify-event", self.motion_notify)
        self.widget.connect("button-press-event", self.on_button_press)
        self.widget.connect("button-release-event", self.on_button_release)
        
    def on_button_press( self, widget=None, event=None ):
        # Set the mouse button as down
        retval = False
        button = event.button
        x = int(event.x)
        y = int(event.y)

        if button != 1:
            return
        self.button_press = True
        self.motion_notify(widget, event)
        
    def on_button_release ( self, widget=None, event=None ):
        # Set the mouse button as up, identify button push or new rating vote
        # make vote submission via XML-RPC
        self.button_press = False
        
    def motion_notify( self, widget=None, event=None ):
        # Get position of the mouse in relation to the current tile, drop if the left button
        # isn't being held. 
        if self.button_press == False:
            return
            
        x = int(event.x)
        y = int(event.y)
        
        if event.window is widget.get_bin_window():
            t = widget.get_path_at_pos(x, y)
            if t is not None:
                path, col, cx, cy = t
                self.update_rating( widget, path, cx, cy )
                
    def update_rating( self, widget, path, x, y ):
        cell_area = widget.get_cell_area(path, widget.get_column(PACK_TILE))
        dummy = Tile(None, False, None, None, None, True, [], cell_area )
        rating = dummy.GetRatingAtPosition(x,y)
        if rating:
            print "New rating = %d" % rating        
        else:
            print "No change"
                             
    def on_install_click( self ):
        pass
    def on_buy_click( self ):
        pass
    def on_uninstall_click( self ):
        pass
    
                
        
    def FilterModel( self, packs, string, filter_fields ):
        filtered_packs = []
        re_filter = re.compile( '.*'+string+'.*', re.I | re.M )
        hit = False
        for index, pack in enumerate(packs):
            if filter_fields == ANY:
                text = pack['name'] + " " + \
                       pack['description'] + " " + \
                       pack['vendor'] + " " + \
                       pack['category'] + " " + \
                       pack['repo'][0]
            elif filter_fields == NAME:
                text = pack['name']
            elif filter_fields == REPOSITORY:
                text = pack['repo'][0]
            elif filter_fields == DESCRIPTION:
                text = pack['description']
            elif filter_fields == CATEGORY:
                text = pack['category']
            elif filter_fields == VENDOR:
                text = pack['vendor']
                
            if re_filter.match( text ):
                hit = True
                log.Debug("Matched application " + pack['name'] + " in search text " + text )
                filtered_packs.append( pack )
        
        self.model = gtk.ListStore( gobject.TYPE_PYOBJECT, 
                                    gobject.TYPE_STRING,
                                    gobject.TYPE_STRING )
        if hit:
            self.widget.set_model( self.CreateModel( filtered_packs ) )
        else:
            self.widget.set_model( self.model )
	        
    def CreateModel( self, packs, queue=False ):
        if not packs:
            packs = packlist.available
            
        for item in packs:
            if queue:
                action, pack = item
            else:
                pack = item
                
            if not os.path.isdir( preferences['wineroot'] + "/wine-doors/icons/" ):
                os.makedirs( preferences['wineroot'] + "/wine-doors/icons/" )
                
            if "icon" in pack:
                icon_url = pack['icon'].split( "/" )
        
                icon_file = icon_url[len( icon_url )-1]
                icon_file = preferences['wineroot'] + "/wine-doors/icons/" + icon_file
        
            if not os.path.isfile( icon_file ):
                urllib.urlretrieve( pack['icon'], icon_file )
            
            title = pack['name']
            icon = icon_file
            short_description = pack['description']
            buttons = []
            
            for pack_version in pack['versions']:
                [( version, 
                   w_version, 
                   variant, 
                   rating, 
                   installersize, 
                   installedsize, 
                   app_pack )] = pack_version
                   
                rating = eval(rating)
                tile_data = title + " " + version, icon, short_description, rating, buttons
            
                self.model.append([tile_data, pack['shortname'], version])
                log.Debug("Pack Name:" + pack['name'] + ", ui.py" )
        
        return self.model

class WineDoorsGUI:
    def __init__( self ):
        self.window = Window( "wn_winedoors", GH_Main )
        self.window['cb_display'].set_active(0)
        self.window['cb_filter'].set_active(0)
        self.PopulateFilter()
        self.tree = PackTree( self.window['tv_packlist'] )

    def __getitem__( self, key ):
        if key == "window":
            return self.window['wn_winedoors']
        return self.window[ key ]
    def PopulateFilter( self ):
    	# Create a list of relevent options from the filter selection
    	# populate the combo entry drop down list
    	pass

class Window:
    def __init__( self, window_name, Handlers=None ):
        glade = os.path.join( sys.path[0], 'winedoors.glade')
        self.widgets = gtk.glade.XML( glade, window_name )
        if not Handlers:
            Handlers = GladeHandlers
        self.widgets.signal_autoconnect( Handlers.__dict__ )
        self.window_init( window_name )
        
    def __getitem__( self, key ):
        return self.widgets.get_widget( key )
    
    # Deprecate this hackish nonsense
    def window_init ( self, window_name ):
        global window
        window = self
        if window_name == "wn_packlist":
            packlist.Update( "System Base" )
            column = gtk.TreeViewColumn( 'Application', gtk.CellRendererText(), text=PACK_NAME )
            column.set_sort_column_id( PACK_NAME )
            self['tv_packlist'].append_column( column )
            column = gtk.TreeViewColumn( 'shortname', gtk.CellRendererText(), text=PACK_SHORTNAME )
            column.set_sort_column_id( PACK_SHORTNAME )
            column.set_visible( False )
            self['tv_packlist'].append_column( column )
            
            self['tv_packlist'].set_model( packlist.CreateTreeModel() )
            self['tv_packlist'].set_search_column( PACK_NAME )
            
if __name__ == "__main__":
    winedoors = WineDoorsGUI()
    gtk.main()
